searchNodes=[{"doc":"Xfile contains augmentations of the built-in File module, such as supporting streams, recursion, and programmatic filtering.","ref":"Xfile.html","title":"Xfile","type":"module"},{"doc":"Like the venerable command-line utility, grep searches lines in the given file using the given pattern, returning only the matching lines as a stream. The given pattern can be one of the following: an arity 1 function which returns a boolean; true indicates a match. a pattern compatible with String.contains?/2 , i.e. a string, a list of strings, or a regular expression. Stream Xfile.grep/2 returns its result as a Stream , so you must remember to convert it to a list via Enum.to_list/1 if you are not lazily evaluating its result. Examples iex(1)&gt; Xfile . grep ( ~r/needle/ , &quot;path/to/file&quot; ) # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; iex(1)&gt; Xfile . grep ( &quot;dir&quot; , &quot;.gitignore&quot; ) |&gt; Enum . to_list ( ) [ &quot;# The directory Mix will write compiled artifacts to. \\n &quot; , &quot;# The directory Mix downloads your dependencies sources to. \\n &quot; ] Using a function to evaluate file lines: iex&gt; f = fn line -&gt; [ serial_number , _ ] = String . split ( line , &quot; &quot; ) String . to_integer ( num ) &gt; 214 end iex&gt; Xfile . grep ( f , &quot;file/w/line-numbers&quot; ) |&gt; Enum . to_list ( ) [ &quot;215 Sprocket \\n &quot; , &quot;216 Gear \\n &quot; , ... ]","ref":"Xfile.html#grep/2","title":"Xfile.grep/2","type":"function"},{"doc":"This function mimics the functionality of grep -rl : it recursively searches all files in the given path, returning only a list of file names (i.e. paths) whose contents have one or more lines that match the pattern. Internally, this relies on grep/2 . Stream Xfile.grep_rl/3 returns its result as a Stream , so you must remember to convert it to a list via Enum.to_list/1 if you are not lazily evaluating its result. See Also grep/2 for searching a single file and returning the matching lines ls/2 using the :filter option to evaluate only the names of the files.","ref":"Xfile.html#grep_rl/3","title":"Xfile.grep_rl/3","type":"function"},{"doc":"As Xfile.line_count/1 , but returns raw results on success or raises on :error .","ref":"Xfile.html#line_count!/1","title":"Xfile.line_count!/1","type":"function"},{"doc":"Counts the number of lines in the given file, offering functionality similar to wc -l . Directories are not allowed. This is just some sugar around File.stream!/1 . Newlines This function technically counts new lines, which may result in &quot;off-by-one&quot; errors when the last line of a file is not terminated with a newline. Examples iex&gt; Xfile . line_count ( &quot;.gitignore&quot; ) { :ok , 27 } iex&gt; Xfile . line_count ( &quot;/tmp&quot; } { :error , :directory }","ref":"Xfile.html#line_count/1","title":"Xfile.line_count/1","type":"function"},{"doc":"As Xfile.ls/2 , but returns raw results on success or raises on :error .","ref":"Xfile.html#ls!/2","title":"Xfile.ls!/2","type":"function"},{"doc":"Like File.ls/1 , this returns the list of files in the given directory, but it makes available some useful options to support recursive listing and filtering results programmatically. Stream Unlike File.ls/1 , Xfile.ls/2 returns its result as a Stream , so you must remember to convert it to a list via Enum.to_list/1 if you are not lazily evaluating its result. Differences between File.ls/1 Xfile.ls/2 returns results as a Stream Xfile.ls/2 returns full paths (relative or absolute) instead of just basenames. Options :recursive indicates whether the directory and its subdirectories should be recursively searched. This can be expressed either as a simple boolean or as a positive integer indicating the maximum depth (where false is equivalent to 0 and would list only the contents of the given directory). Default: true :filter can be either a regular expression to be used with String.match?/2 OR an arity 1 function that receives the full file path and returns a boolean value. If the filter operation returns true , the file will be included in the output. Any other output will cause the file to be filtered from the output. Optional. Examples Use a regular expression to return only .txt files: iex&gt; { :ok , stream } = Xfile . ls ( &quot;path/to/files&quot; , filter : ~r/ \\. txt$/ ) { :ok , # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; } iex&gt; Enum . to_list ( stream ) [ &quot;path/to/files/a.txt&quot; , &quot;path/to/files/b.txt&quot; , &quot;path/to/files/subdir/c.txt&quot; ] Use a function to apply more complex logic to filter the results: iex&gt; { :ok , stream } = Xfile . ls ( &quot;mydir&quot; , filter : fn x -&gt; stat = File . stat! ( x ) stat . size &gt; 1024 end ) { :ok , # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; } iex&gt; Enum . to_list ( stream ) [ &quot;mydir/big-file&quot; , &quot;mydir/big-file2&quot; , # ... ] Limit the depth of the recursion to the given directory and its subdirectories, but no further: iex&gt; { :ok , stream } = Xfile . ls ( &quot;top/dir&quot; , recursive : 1 ) { :ok , # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; } iex&gt; Enum . to_list ( stream ) [ &quot;top/dir/a&quot; , &quot;top/dir/b&quot; , # ... &quot;top/dir/sub1/x&quot; , &quot;top/dir/sub1/y&quot; ]","ref":"Xfile.html#ls/2","title":"Xfile.ls/2","type":"function"},{"doc":"Xfile is a utility module providing augmentations to the functions in the built-in File module, specifically adding useful functionality to the ls function.","ref":"readme.html","title":"Xfile","type":"extras"},{"doc":"Use a regular expression to return only .txt files: iex&gt; { :ok , stream } = Xfile . ls ( &quot;path/to/files&quot; , filter : ~r/ \\\\ .txt$/ ) { :ok , # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; } iex&gt; Enum . to_list ( stream ) [ &quot;path/to/files/a.txt&quot; , &quot;path/to/files/b.txt&quot; , &quot;path/to/files/subdir/c.txt&quot; ] Use a function to apply more complex logic to filter the results: iex&gt; { :ok , stream } = Xfile . ls ( &quot;mydir&quot; , filter : fn x -&gt; stat = File . stat! ( x ) stat . size &gt; 1024 end ) { :ok , # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; } iex&gt; Enum . to_list ( stream ) [ &quot;mydir/big-file&quot; , &quot;mydir/big-file2&quot; , # ... ] Limit the depth of the recursion to the given directory and its subdirectories, but no further: iex&gt; { :ok , stream } = Xfile . ls ( &quot;top/dir&quot; , recursive : 1 ) { :ok , # Function &lt; 59.58486609 / 2 in Stream . transform / 3 &gt; } iex&gt; Enum . to_list ( stream ) [ &quot;top/dir/a&quot; , &quot;top/dir/b&quot; , # ... &quot;top/dir/sub1/x&quot; , &quot;top/dir/sub1/y&quot; ]","ref":"readme.html#examples","title":"Xfile - Examples","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding xfile to your list of dependencies in mix.exs : def deps do [ { :xfile , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/xfile .","ref":"readme.html#installation","title":"Xfile - Installation","type":"extras"},{"doc":"Alien by Martin Smith from NounProject.com","ref":"readme.html#image-attribution","title":"Xfile - Image Attribution","type":"extras"},{"doc":"The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Initial release.","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]